<?php

namespace CRM\Service;

use CRM\Factory\Ger91600TipoDeAtividadeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Ger91600TipoDeAtividadeService {

    protected $TipoDeAtividadeFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, Ger91600TipoDeAtividadeFactory $TipoDeAtividadeFactory)
    {
        $this->TipoDeAtividadeFactory       = $TipoDeAtividadeFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }
    public function getTypeOfActivityService () {

        return $this->TipoDeAtividadeFactory->getTypeOfActivityFactory();

    }

    public function getFieldOfActivityService () {

        return $this->TipoDeAtividadeFactory->getFieldOfActivityFactory();

    }

    public function saveNewActivityService ($row) {
       
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();
        $this->connection->beginTransaction();
        try {
            foreach ($row["DRG"] as $rows) {

                if ($rows["NRSEQTPATIVCLI"] == 0) {

                    $rows["NRSEQTPATIVCLI"] = $this->newCode->getCodeByTableName("ATIVCLIENTE", $nrorg, 1, 10, true);
                   
                    $params = array(
                    "NRSEQTPATIVCLI" => $rows["NRSEQTPATIVCLI"],
                    "CDATIVCLI"      => $rows["CDATIVCLI"],
                    "IDATIVO"        => $rows["IDATIVO"],
                    "DSTPATIVCLIENTE"=> $rows["DSTPATIVCLIENTE"],
                    "NRORG"          => $nrorg,
                    "NRORGINCLUSAO"  => $nrorg,
                    "NRORGULTATU"    => $nrorg,
                    "CDOPERINCLUSAO" => $cdoperador,
                    "CDOPERULTATU" => $cdoperador
                    );
                    
                    $this->TipoDeAtividadeFactory->insertNewActivityFactory($params);

                } else {

                    $params = array(
                    "NRSEQTPATIVCLI" => $rows["NRSEQTPATIVCLI"],
                    "CDATIVCLI"      => $rows["CDATIVCLI"],
                    "IDATIVO"        => $rows["IDATIVO"],
                    "DSTPATIVCLIENTE"=> $rows["DSTPATIVCLIENTE"],
                    "NRORG"          => $nrorg,
                    "NRORGINCLUSAO"  => $nrorg,
                    "NRORGULTATU"    => $nrorg,
                    "CDOPERINCLUSAO" => $cdoperador,
                    "CDOPERULTATU"   => $cdoperador
                    );
                   
                    $this->TipoDeAtividadeFactory->updateActivityFactory($params);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteActivityService ($row) {
        
        $this->connection->beginTransaction();
        try {
            foreach ($row["NRSEQTPATIVCLI"] as $key => $rows) {
                
                $relationships = $this->findRelationship($rows);
               
              if ($relationships[0]["NRSEQTPATIVCLI"] == 0 ) {
                  $params = array(
                  "NRSEQTPATIVCLI" => $rows,
              );
  
              $this->TipoDeAtividadeFactory->deleteActivityFactory($params);

              } else {

                throw new \Exception("Esse Tipo de Atividade Não Pode Ser Excluida, Pois Já Está Sendo Utilizada!");

              }

            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function findRelationship ($rows) {
        $params = array(
            "NRSEQTPATIVCLI" => $rows,
        );
        return $this->TipoDeAtividadeFactory->findRelationshipFactory($params);
    }
}