import { ZdPage } from '@zeedhi/vue';

const routes = [
  {
    path: '/auth/login',
    name: 'login',
    component: ZdPage,
    props: {
      path: 'login',
      local: true,
    },
  },
  {
    path: '/',
    name: 'home',
    component: ZdPage,
    props: () => ({
      path: 'home',
      local: true,
    }),
  },
  {
    path: '/modules/:module/:page',
    name: 'microservice',
    component: () => import('../views/Microservice.vue'),
  },
  {
    path: '/ger10120_segmento_mercado',
    name: 'Sergmento Mercado',
    component: ZdPage,
    props: {
      path: '/ger10120_segmento_mercado/ger10120_segmento_mercado',
      local: true,
    },
  },
  {
    path: '/ger91600_tipo_atividade',
    name: 'Tipo de Atividade',
    component: ZdPage,
    props: {
      path: '/ger91600_tipo_atividade/ger91600_tipo_atividade',
      local: true,
    },
  },
  {
    path: '/crm_modo_de_divulgacao',
    name: 'Modo de Divulgação',
    component: ZdPage,
    props: {
      path: '/crm_modo_de_divulgacao/crm_modo_de_divulgacao',
      local: true,
    },
  },
  {
    path: '*',
    component: ZdPage,
    props: {
      path: 'notfound',
      local: true,
    },
  },
];

export default routes;
